%define section         free

%define REQ_AP2_REL %(rpm -q --queryformat "%{VERSION}" apache2)

%define buildwa13       0
%define buildwa20       0
%define buildjk13       1
%define buildjk20       1
%define buildjk213      0 
%define buildjk220      0

%define name            tomcat-connectors
%define version         1.2.0
%define packname        jakarta-tomcat-connectors-jk-%{version}-src
%define release         1jpp
%define summary         Tomcat connectors for Apache HTTPD servers
%define license         Apache License
%define vendor          JPackage Project
%define distribution    JPackage


%define tomcat3dir      /var/tomcat3
%define tomcat4dir      /var/tomcat4
%define javadir         %{_datadir}/java
%define javadocdir      %{_datadir}/javadoc
%define ap13confdir     /etc/httpd/conf
%define ap13logdir      /var/log/httpd
%define ap13rundir      /var/run
%define	ap13config	%{ap13confdir}/httpd.conf
%define ap13incdir      /usr/include/apache
%define ap13libdir      /usr/lib/apache
%define ap20confdir     /etc/httpd2/conf
%define ap20logdir      /var/log/httpd2
%define ap20rundir      /var/run
%define	ap20config	%{ap20confdir}/httpd2.conf
%define ap20incdir      /usr/include/apache2
%define ap20libdir      /usr/lib/apache2

Summary: 	%{summary}
Name: 	    	%{name}
Version: 	%{version}
Release: 	%{release}
Vendor: 	%{vendor}
Distribution:	%{distribution}
License:        %{license}
Group: 		System Environment/Daemons
Url: 		http://jakarta.apache.org/tomcat
Source:         http://jakarta.apache.org/builds/jakarta-tomcat-connectors/jk/release/1.2.0/src/%{packname}.tar.gz
Source1:        mod_jk.conf
Source2:        workers.properties
Source4:        workers2.properties
Source5:        mod_webapp.conf
BuildRoot:      /var/tmp/%{name}-root
Packager:       Henri Gomez <hgomez@users.sourceforge.net>
BuildRequires: 	libtool

%if %{buildjk13} || %{buildwa13} || %{buildjk213}
BuildRequires:  apache-devel
%endif

%if %{buildjk20} || %{buildwa20} || %{buildjk220}
BuildRequires:  apache2-devel
%endif

%description
Tomcat 3.3 and 4.0 connectors for Apache 1.3/2.0

%package -n mod_webapp-ap13
Group:          System Environment/Daemons 
Summary:        mod_webapp connector to Tomcat 4.x for Apache 1.3
Requires:       apache

%description -n mod_webapp-ap13
mod_webapp is a connector to link Apache 1.3 to Tomcat 4.x using webapp protocol


%package -n mod_webapp-ap20
Group:          System Environment/Daemons
Summary:        mod_webapp connector to Tomcat 4.x for Apache 1.3
Requires:       apache2 = %{REQ_AP2_REL}

%description -n mod_webapp-ap20
mod_webapp is a connector to link Apache 1.3 to Tomcat 4.x using webapp protocol


%package -n mod_jk-ap13
Group:          System Environment/Daemons
Summary:        mod_jk connector to Tomcat 3.x & 4.x for Apache 1.3
Requires:       apache

%description -n mod_jk-ap13
mod_jk is the original connector to link Apache 1.3 to Tomcat 3.x & 4.x using ajp protocols


%package -n mod_jk-ap20
Group:          System Environment/Daemons
Summary:        mod_jk connector to Tomcat 3.x & 4.x for Apache 2.0
Requires:       apache2 = %{REQ_AP2_REL}

%description -n mod_jk-ap20
mod_jk is the original connector to link Apache 2.0 to Tomcat 3.x & 4.x using ajp protocols


%package -n mod_jk2-ap13
Group:          System Environment/Daemons
Summary:        mod_jk2 connector to Tomcat 3.x & 4.x for Apache 1.3
Requires:       apache

%description -n mod_jk2-ap13
mod_jk2 is the new connector to link Apache 1.3 to Tomcat 3.x & 4.x using ajp protocols


%package -n mod_jk2-ap20
Group:          System Environment/Daemons
Summary:        mod_jk2 connector to Tomcat 3.x & 4.x for Apache 2.0
Requires:       apache2 = %{REQ_AP2_REL}

%description -n mod_jk2-ap20
mod_jk2 is the new connector to link Apache 2.0 to Tomcat 3.x & 4.x using ajp protocols


%prep
rm -rf $RPM_BUILD_ROOT
rm -rf $RPM_BUILD_DIR/%{name}
%setup -n %{packname}

%build

# build webapp for Apache 1.3
%if %{buildwa13}
cd webapp
./support/buildconf.sh
cd ..
%endif

# build webapp for Apache 2.0
%if %{buildwa20}
cd webapp
./support/buildconf.sh
cd ..
%endif

# build jk for Apache 1.3
%if %{buildjk13}
cd jk/native
[ ! -x ./configure ] && sh ./buildconf.sh
# build jk for Apache 1.3
./configure --with-apxs=/usr/sbin/apxs --enable-jni
make 
mv apache-1.3/mod_jk.so.0.0.0 ../../mod_jk-1.3.so
mv jni/jk_jnicb.so ../../jk_jnicb-1.3.so
cd ../..
%endif

# build jk for Apache 2.0
%if %{buildjk20}
cd jk/native
[ ! -x ./configure ] && sh ./buildconf.sh
./configure --with-apxs=/usr/sbin/apxs2 --enable-jni
make clean
make
mv apache-2.0/mod_jk.so ../../mod_jk-2.0.so
mv jni/jk_jnicb.so ../../jk_jnicb-2.0.so
cd ../..
%endif

# build jk2 for Apache 1.3
%if %{buildjk213}
cd jk/native2
[ ! -x ./configure ] && sh ./buildconf.sh
./configure --with-apxs=/usr/sbin/apxs
make 
mv ../build/jk2/apache13/mod_jk2.so ../../mod_jk2-1.3.so
cd ../..
%endif

# build jk2 for Apache 2.0
%if %{buildjk220}
cd jk/native2
[ ! -x ./configure ] && sh ./buildconf.sh
./configure --with-apxs2=/usr/sbin/apxs2
make
mv ../build/jk2/apache2/mod_jk2.so ../../mod_jk2-2.0.so
mv ../build/jk2/apache2/jkjni.so ../../jkjni-2.0.so
cd ../..
%endif

%install
mkdir -p $RPM_BUILD_ROOT/%{ap13libdir}
mkdir -p $RPM_BUILD_ROOT/%{ap13confdir}
mkdir -p $RPM_BUILD_ROOT/%{ap20libdir}
mkdir -p $RPM_BUILD_ROOT/%{ap20confdir}

%if %{buildwa13}
cp %{SOURCE5} $RPM_BUILD_ROOT/%{ap13confdir}
%endif 

%if %{buildwa20}
cp %{SOURCE5} $RPM_BUILD_ROOT/%{ap20confdir}
%endif 

%if %{buildjk13}
install mod_jk-1.3.so $RPM_BUILD_ROOT/%{ap13libdir}/mod_jk.so
install jk_jnicb-1.3.so $RPM_BUILD_ROOT/%{ap13libdir}/jk_jnicb.so
cp %{SOURCE1} $RPM_BUILD_ROOT/%{ap13confdir}
cp %{SOURCE2} $RPM_BUILD_ROOT/%{ap13confdir}
for i in $RPM_BUILD_ROOT/%{ap13confdir}/mod_jk.conf $RPM_BUILD_ROOT/%{ap13confdir}/workers.properties; do
	perl -pi -e "s|\@confdir\@|%{ap13confdir}|g;" ${i}
	perl -pi -e "s|\@logdir\@|%{ap13logdir}|g;" ${i}
	perl -pi -e "s|\@rundir\@|%{ap13rundir}|g;" ${i}
	perl -pi -e "s|\@ap\@|ap13|g;" ${i}
	perl -pi -e "s|\@tomcatdir\@|%{tomcat3dir}|g;" ${i}
done
%endif

%if %{buildjk20}
install mod_jk-2.0.so $RPM_BUILD_ROOT/%{ap20libdir}/mod_jk.so
install jk_jnicb-2.0.so $RPM_BUILD_ROOT/%{ap20libdir}/jk_jnicb.so
cp %{SOURCE1} $RPM_BUILD_ROOT/%{ap20confdir}
cp %{SOURCE2} $RPM_BUILD_ROOT/%{ap20confdir}
for i in $RPM_BUILD_ROOT/%{ap20confdir}/mod_jk.conf $RPM_BUILD_ROOT/%{ap20confdir}/workers.properties; do
        perl -pi -e "s|\@confdir\@|%{ap20confdir}|g;" ${i}
        perl -pi -e "s|\@logdir\@|%{ap20logdir}|g;" ${i}
        perl -pi -e "s|\@rundir\@|%{ap20rundir}|g;" ${i}
	perl -pi -e "s|\@ap\@|ap20|g;" ${i}
        perl -pi -e "s|\@tomcatdir\@|%{tomcat3dir}|g;" ${i}
done
%endif

%if %{buildjk213}
install mod_jk2-1.3.so $RPM_BUILD_ROOT/%{ap13libdir}/mod_jk2.so
cp %{SOURCE4} $RPM_BUILD_ROOT/%{ap13confdir}
for i in $RPM_BUILD_ROOT/%{ap13confdir}/workers2.properties; do
        perl -pi -e "s|\@confdir\@|%{ap13confdir}|g;" ${i}
        perl -pi -e "s|\@logdir\@|%{ap13logdir}|g;" ${i}
        perl -pi -e "s|\@rundir\@|%{ap13rundir}|g;" ${i}
	perl -pi -e "s|\@ap\@|ap13|g;" ${i}
        perl -pi -e "s|\@tomcatdir\@|%{tomcat3dir}|g;" ${i}
done
%endif

%if %{buildjk220}
install mod_jk2-2.0.so $RPM_BUILD_ROOT/%{ap20libdir}/mod_jk2.so
install jkjni-2.0.so $RPM_BUILD_ROOT/%{ap20libdir}/jkjni.so
cp %{SOURCE4} $RPM_BUILD_ROOT/%{ap20confdir}
for i in $RPM_BUILD_ROOT/%{ap20confdir}/workers2.properties; do
        perl -pi -e "s|\@confdir\@|%{ap20confdir}|g;" ${i}
        perl -pi -e "s|\@logdir\@|%{ap20logdir}|g;" ${i}
        perl -pi -e "s|\@rundir\@|%{ap20rundir}|g;" ${i}
	perl -pi -e "s|\@ap\@|20|g;" ${i}
        perl -pi -e "s|\@tomcatdir\@|%{tomcat3dir}|g;" ${i}
done
%endif

strip $RPM_BUILD_ROOT/%{ap13libdir}/*.so
strip $RPM_BUILD_ROOT/%{ap20libdir}/*.so

%clean
rm -rf $RPM_BUILD_ROOT


%post -n mod_webapp-ap13
if [ -f %{ap13config} ] ; then
    if ! grep -q 'HAVE_WEBAPP' %{ap13config} ; then
        cat >>%{ap13config}<<EOT

<IfDefine HAVE_WEBAPP>
LoadModule webapp_module modules/mod_jk.so
AddModule  mod_webapp.c
Include %{ap13confdir}/mod_webapp.conf
</IfDefine>
EOT
    fi
fi


%post -n mod_webapp-ap20
if [ -f %{ap20config} ] ; then
    if ! grep -q 'HAVE_WEBAPP' %{ap20config} ; then
        cat >>%{ap20config}<<EOT
<IfDefine HAVE_WEBAPP>
LoadModule webapp_module /usr/lib/apache2/mod_webapp.so
Include %{ap20confdir}/mod_webapp.conf
</IfDefine>
EOT
    fi
fi



%post -n mod_jk-ap13
if [ -f %{ap13config} ] ; then
    if ! grep -q 'HAVE_JK' %{ap13config} ; then
        cat >>%{ap13config}<<EOT

<IfDefine HAVE_JK>
LoadModule jk_module modules/mod_jk.so
AddModule  mod_jk.c
Include %{ap13confdir}/mod_jk.conf
</IfDefine>
EOT
    fi
fi


%post -n mod_jk-ap20
if [ -f %{ap20config} ] ; then
    if ! grep -q 'HAVE_JK' %{ap20config} ; then
        cat >>%{ap20config}<<EOT
<IfDefine HAVE_JK>
LoadModule jk_module /usr/lib/apache2/mod_jk.so
Include %{ap20confdir}/mod_jk.conf
</IfDefine>
EOT
    fi
fi


%post -n mod_jk2-ap13
if [ -f %{ap13config} ] ; then
    if ! grep -q 'HAVE_JK2' %{ap13config} ; then
        cat >>%{ap13config}<<EOT
<IfDefine HAVE_JK2>
LoadModule jk2_module modules/mod_jk2.so
AddModule  mod_jk2.c
Include %{ap13confdir}/mod_jk2.conf
</IfDefine>
EOT
    fi
fi


%post -n mod_jk2-ap20
if [ -f %{ap20config} ] ; then
    if ! grep -q 'HAVE_JK2' %{ap20config} ; then
        cat >>%{ap20config}<<EOT
<IfDefine HAVE_JK2>
LoadModule jk2_module /usr/lib/apache2/mod_jk2.so
Include %{ap20confdir}/mod_jk2.conf
</IfDefine>
EOT
    fi
fi


%if %{buildwa13}
%files -n mod_webapp-ap13
%attr( - ,root,root)						%{ap13libdir}/mod_webapp.so
%doc LICENSE
%endif

%if %{buildwa20}
%files -n mod_webapp-ap20
%attr( - ,root,root)                        %{ap20libdir}/mod_webapp.so
%doc LICENSE
%endif

%if %{buildjk13}
%files -n mod_jk-ap13
%attr( - ,root,root)                        %{ap13libdir}/mod_jk.so
%attr( - ,root,root)                        %{ap13libdir}/jk_jnicb.so
%attr(644,root,root)  %config(noreplace)    %{ap13confdir}/mod_jk.conf
%attr(644,root,root)  %config(noreplace)    %{ap13confdir}/workers.properties
%doc LICENSE
%endif

%if %{buildjk20}
%files -n mod_jk-ap20
%attr( - ,root,root)                        %{ap20libdir}/mod_jk.so
%attr( - ,root,root)                        %{ap20libdir}/jk_jnicb.so
%attr(644,root,root)  %config(noreplace)    %{ap20confdir}/mod_jk.conf
%attr(644,root,root)  %config(noreplace)    %{ap20confdir}/workers.properties
%doc LICENSE
%endif

%if %{buildjk213}
%files -n mod_jk2-ap13
%attr( - ,root,root)                        %{ap13libdir}/mod_jk2.so
%attr(644,root,root)  %config(noreplace)    %{ap13confdir}/workers2.properties
%doc LICENSE
%endif

%if %{buildjk220}
%files -n mod_jk2-ap20
%attr( - ,root,root)                        %{ap20libdir}/mod_jk2.so
%attr( - ,root,root)                        %{ap20libdir}/jkjni.so
%attr(644,root,root)  %config(noreplace)    %{ap20confdir}/workers2.properties
%doc LICENSE
%endif

%changelog
* Wed Sep 25 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.0.jk1.2.0-1jpp
- jtc snapshot from JK 1.2.0 release

* Fri Aug 22 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.0.4.1.9-1jpp
- jtc snapshot from tomcat 4.1.9 beta
- webapp not build since it requires autoconf > 2.5 not available in rpm distribs 

* Thu Feb 14 2002 Henri Gomez <hgomez@users.sourceforge.net>
- Initial tomcat-connectors release
- use the jakarta-tomcat-connectors-4.0.2-01-src 
  (which correct some auth problems with ajp13)

